#include "vars.h"
#include "moves.h"
#include "sfx.h"
#include "sounds.h"


void move_ball(BALL *p_ball) {
   int i;
   
   p_ball->position.x += p_ball->speed.x;
   p_ball->position.y += p_ball->speed.y;
   
   
   //maintenant, on regarde si a ne tape pas sur le bord de l'cran

   //en hauteur
   if (p_ball->position.y - p_ball->bitmap->h/2 < 0  && p_ball->speed.y < 0) {
      p_ball->speed.y = -(p_ball->speed.y);
      play_sound(data_sfx[BORD_WAV].dat, p_ball->position.x);
   }
   else if (p_ball->position.y + p_ball->bitmap->h/2 >= SCREEN_H  && p_ball->speed.y > 0) {
      p_ball->speed.y = -(p_ball->speed.y);
      play_sound(data_sfx[BORD_WAV].dat, p_ball->position.x);
   }
   //maintenant, si en largeur ca marche, c'est que c'est perdu pour le joueur cens la ratrapper!
  
   if (p_ball->position.x - p_ball->bitmap->w/2 >= SCREEN_W && p_ball->speed.x > 0) {
      --nb_current_balls;//le nombre de balles actuel
      p_ball->EXIST = FALSE;
      
      if (nb_current_balls <= 0) {//on dfinit qui a gagn!
         game_info.winning_side = LEFT;
         ++(game_info.nb_left_wins);
      }
      
      return; //on s'arrete l
   }
   if (p_ball->position.x + p_ball->bitmap->w/2 < 0  && p_ball->speed.x < 0) {
      --nb_current_balls;//le nombre de balles actuel
      p_ball->EXIST = FALSE;
      
      if (nb_current_balls <= 0) {//on dfinit qui a gagn!
         game_info.winning_side = RIGHT;
         ++(game_info.nb_right_wins);
      }
         
      return;  //pas la peine de continuer
   }
      
   
   //Nouveau systme : on parcourt la liste des joueurs et on effectue les tests de collision si ncssaire
   for (i = 0; i < nb_max_players; ++i) {
      if ((p_ball->speed.x < 0 && player[i]->pos != LEFT) || (p_ball->speed.x > 0 && player[i]->pos != RIGHT))
         continue;

      if (detect_collision(p_ball->bitmap, p_ball->position.x-p_ball->bitmap->w/2, p_ball->position.y-p_ball->bitmap->h/2, player[i]->racket->bitmap, player[i]->racket->position.x - player[i]->racket->bitmap->w/2, player[i]->racket->position.y - player[i]->racket->bitmap->h/2)) {
         //il y a eu collision, il faut grer le pitch que donne la raquette sur la balle!
         gere_ball_racket_collision(p_ball, player[i]->racket);
         current_score++; //on a tap sur une raquette -> on augmente le score
      }
   }   
   return;
}

void move_racket(RACKET *p_racket) {
   p_racket->position.x += p_racket->speed.x;//je le fais quand mme mais bon...:)
   p_racket->position.y += p_racket->speed.y;

   //on ne doit pas sortir de l'cran
   if (p_racket->position.y-p_racket->bitmap->h/2 < 0) {
      p_racket->position.y = p_racket->bitmap->h/2;
      p_racket->speed.y = 0; //on la stoppe compltement
   }
   else if (p_racket->position.y + p_racket->bitmap->h/2 >= SCREEN_H) {
      p_racket->position.y = SCREEN_H - p_racket->bitmap->h/2;
      p_racket->speed.y = 0; //on la stoppe compltement
   }
      
   

   if (p_racket-> IS_MOVING == FALSE) {
      if (p_racket->speed.y != 0) {
         if (p_racket->speed.y > 0) {
            p_racket->speed.y -= 0.002;
            if (p_racket->speed.y < 0)
               p_racket->speed.y = 0;
         }
         else {
            p_racket->speed.y += 0.002;
            if (p_racket->speed.y > 0)
               p_racket->speed.y = 0;
         }
      }
   }

   return;
}   
   


//Fonction trs importante: elle determine si il y a collision entre les bitmaps "bitmap1" et "bitmap2"
int detect_collision(BITMAP *bitmap1, int coorx_1, int coory_1, BITMAP *bitmap2, int coorx_2, int coory_2)
{
   int rect1_x, rect1_y; /* the coordinates of the rectangle of    */
   int rect2_x, rect2_y; /* overlap of the bitmaps' bounding boxes */

   int i, j, k, l;

   int mask1, mask2;

   /* We start by checking if the bitmaps' bounding boxes overlap. */
   /* In x: */
   if (coorx_1 + bitmap1->w <= coorx_2 || coorx_1 >= coorx_2 + bitmap2->w)
      return FALSE;
   /* In y: */
   if (coory_1 + bitmap1->h <= coory_2 || coory_1 >= coory_2 + bitmap2->h)
      return FALSE;

   /* Right, now that we know the bounding boxes overlap,
    * we need to determine the four corners of the overlap area.
    */

   /* We'll handle the x-coordinates first... */
   if (coorx_1 < coorx_2) {
      rect1_x = coorx_2;
      if (coorx_1 + bitmap1->w >= coorx_2 + bitmap2->w)
         rect2_x = coorx_2 + bitmap2->w;
      else 
         rect2_x = coorx_1 + bitmap1->w;
   }
   else {
      rect1_x = coorx_1;
      if (coorx_2 + bitmap2->w >= coorx_1 + bitmap1->w)
         rect2_x = coorx_1 + bitmap1->w;
      else 
         rect2_x = coorx_2 + bitmap2->w;
   }

   /* ...and now the y-coordinates. */
   if (coory_1 < coory_2) {
      rect1_y = coory_2;
      if (coory_1 + bitmap1->h >= coory_2 + bitmap2->h)
         rect2_y = coory_2 + bitmap2->h;
      else 
         rect2_y = coory_1 + bitmap1->h;
   }
   else {
      rect1_y = coory_1;
      if (coory_2 + bitmap2->h > coory_1 + bitmap1->h)
         rect2_y = coory_1 + bitmap1->h;
      else 
         rect2_y = coory_2 + bitmap2->h;
   }

   mask1 = bitmap_mask_color(bitmap1);
   mask2 = bitmap_mask_color(bitmap2);

   for (i = rect1_x - coorx_1, j = rect1_x - coorx_2; i < rect2_x - coorx_1; i++, j++) {
      for (k = rect1_y - coory_1, l = rect1_y - coory_2; k < rect2_y - coory_1; k++, l++) {
         if (getpixel(bitmap1, i, k) != mask1 && getpixel(bitmap2, j, l) != mask2)
            return TRUE;
      }
   }

   return FALSE;
}  

void gere_ball_racket_collision(BALL *p_ball, RACKET *p_racket) {
   
   //un petit son de collision?
   play_sound(data_sfx[BRIQUE_WAV].dat, p_racket->position.x);
      
   
   
   //si la raquette ne bouge pas, on se contente de renvoyer 
   p_ball->speed.x = -(p_ball->speed.x); //dj, on inverse la direction horizontale!   
   
   //voyons tout d'bord si les sens de dplacement verticaux sont identiques.
   if ((p_ball->speed.y < 0 && p_racket->speed.y < 0) || (p_ball->speed.y > 0 && p_racket->speed.y > 0)) {
      p_ball->speed.y += p_racket->speed.y;
      p_ball->speed.x *= 1.01; //on accelere quand mme la balle de 1%
   }
   else {
      p_ball->speed.y += p_racket->speed.y;
      p_ball->speed.x *= (1 + ABS(p_racket->speed.y*0.1)/ABS(p_ball->speed.x));
   }
   
   //limitation de la vitesse de la balle!
   if (cur_level->max_ball_speed.y != NOT_DEFINED) {
      if (p_ball->speed.y > cur_level->max_ball_speed.y)
         p_ball->speed.y = cur_level->max_ball_speed.y;
      else if (p_ball->speed.y < -cur_level->max_ball_speed.y)
         p_ball->speed.y = -cur_level->max_ball_speed.y;
   }
   if (cur_level->max_ball_speed.x != NOT_DEFINED) {
      if (p_ball->speed.x > cur_level->max_ball_speed.x)
         p_ball->speed.x = cur_level->max_ball_speed.x;
      else if (p_ball->speed.x < -cur_level->max_ball_speed.x)
         p_ball->speed.x = -cur_level->max_ball_speed.x;
   }
      
      
   //p_ball->speed.y *= (ABS(p_racket->speed.y + 1));
         
   return;
}